<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\api\lists\suyuan_operation;


use app\common\lists\BaseDataLists;
use app\common\model\suyuan_operation\AnimalOperateAction;
use app\common\model\suyuan_operation\OperationDisinfectLog;
use app\common\model\suyuan_operation\OperationFeedingLog;
use app\common\lists\ListsSearchInterface;


/**
 * OperationFeedingLog列表
 * Class OperationFeedingLogLists
 * @package app\api\listssuyuan_operation
 */
class OperationFeedingLogLists extends BaseDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/01/15 10:09
     */
    public function setSearch(): array
    {
        return [
            '=' => ['animal_info_id', 'fence_house_id'],

        ];
    }


    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/01/15 10:09
     */
    public function lists(): array
    {
        $animal_info_id = $this->request->get('animal_info_id', 0)? $this->request->get('animal_info_id'): 0;
        $fence_house_id = $this->request->get('fence_house_id', 0)? $this->request->get('fence_house_id'): 0;
        $list =  AnimalOperateAction::whereRaw("animal_info_id = {$animal_info_id} or fence_house_id={$fence_house_id}")->where('type', 3)
            ->with(['fenceHouseAttr', 'animalInfo'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->each(function($item){
                $item['detail'] = json_decode($item['detail'],true);
                return $item;
            })
            ->toArray();
        return  $list;
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/01/15 10:09
     */
    public function count(): int
    {
        $animal_info_id = $this->request->get('animal_info_id', 0)? $this->request->get('animal_info_id'): 0;
        $fence_house_id = $this->request->get('fence_house_id', 0)? $this->request->get('fence_house_id'): 0;
        return AnimalOperateAction::whereRaw("animal_info_id = {$animal_info_id} or fence_house_id={$fence_house_id}")->where('type', 3)->count();
    }

}